#!/bin/bash

# myservice_oroscopo
# Version 1.6
# By UDA'Software 2009

# FUNZIONE INTERNA _ NON TOCCARE; LEGGERE OLTRE
function check_command_string() {
    if [ "${command_string}" == "" ]; then
	echo "/SAY ${remote_user}, non ho capito cosa volevi fare, vuoi essere piu' chiaro ? ^!^"
	
	exit 1;
    fi
}
# FINE FUNZIONE INTERNA

# SETUP
#

# Impostazione delle variabili
local_user=${1}
remote_user=${2}
remote_host=${3}
channel=${4}
hostname=${5}
server=${6}
data=${7}

# ${local_user} e' la variabile che conterra' il nickname dell'utente
# locale (in genere sara' il nick del BOT).

# ${remote_user} e' la variabile che conterra' il nickname dell'utente
# che ha lanciato il comando.

# ${remote_host} e' la variabile che conterra' l'hostname dell'utente
# remoto che ha lanciato il comando.

# ${channel} e' la variabile che conterra' il nome del canale nel
# quale e' stato eseguito il comando; se il comando e' stato eseguito
# in privato (QUERY) al BOT, sara' il suo stesso nickname (quindi
# uguale alla variabile ${local_user}).

# ${hostname} e' la variabile che conterra' il nome del network nel
# quale e' stato eseguito il comando.

# ${server} e' la variabile che conterra' il nome del server nel quale
# e' stato eseguito il comando.

# ${data} conterra' il nome del comando stesso (ex: !oroscopo) e gli
# eventuali parametri.

# Qui viene verificato che non si tenti di utilizzare il comando in
# modo inappropriato, ad esempio concatenando piu' comando (ex:
# !op|!date|!mycommand)
[ $(echo "${data}" | grep -v '^!oroscopo' | grep '^!' | tr '[:punct:][:space:]' '_') ] && exit 2;

# Qui viene controllato che la libreria esterna contenente la funzione
# di validazione dell'identificazione degli utenti.
if [ ! -f $(dirname ${0})/budus_validate.sh ]; then
    echo "/SAY ERRORE $(dirname $0)/budus_validate.sh non trovato, versione del BOT errata."
    
    exit 1;
fi

# Verifica che l'identificazione dell'utente sia regolare; sara'
# possibile usare il comando offerto da questo script solo dopo che si
# e' mantenuto il nickname per almeno 60 secondi.
# Se si desidera disabilitare questo controllo e' necessario
# aggiungere un # in testa a validate_user.
source $(dirname ${0})/budus_validate.sh
validate_user

# Ricerca della directory temporanea; se si necessita di creare dei
# files temporanei, sarebbe opportuno collocarli in $HOME/tmp.
if [ ! -d ${HOME}/tmp ]; then
    echo "/SAY %C4,1Error:%C3,1 directory%C7,1 ${HOME}/tmp%C3,1 don't found !"
    exit 1;
fi

# Calcola il percorso dove e' collocato lo script.
script_path=$(echo ${0} | sed s/\\\/myservice_oroscopo.sh//)
# Evita di eseguire il comando se non c'e' un file degli accessi
if [ ! -f ${script_path}/operator.lst ]; then
    echo "/SAY Non e' stato trovato il database contenente la lista degli utenti abilitati a comandarmi."
    echo "/SAY Mi rifiuto di continuare; contattare l'Amministratore."
    exit 1;
fi

# Verifica che in "operator.lst" il nickname dell'utente remoto che ha
# lanciato il comando risulti in qualche modo abilitato.
findnick=$(grep -iFe "all:" -iFe "${channel}:" ${script_path}/operator.lst | grep -iFe "/${remote_user}/" -iFe "/${remote_user}>oroscopo/")

command_string=$(echo "${data}" | sed s/!oroscopo\ // | sed s/!oroscopo// | cut -f1- -d' ')

# ***** PERSONALIZZAZIONE *****
# Se e' previsto che il comando che si vuole realizzare venga
# invocato con dei parametri, togliere il "#" alla riga qui
# sotto:
#check_command_string

# ***** PERSONALIZZAZIONE *****
# Se non e' previsto che il comando debba essere utilizzato
# esclusivamente da utenti abilitati, togliere il "#" alla riga qui
# sotto:
findnick="NOAUTH"

if [ "${findnick}" != "" ];then
    # ***** PERSONALIZZAZIONE INIZIO *****
	
    tclsh ${script_path}/oroscopo-1.2_mod-1.6.tcl "${remote_user}" "${channel}" "${command_string}"
	
    # ***** PERSONALIZZAZIONE FINE *****
else
    echo "/SAY ${remote_user}, non mi risulta che tu abbia i privilegi adeguati per usare %B!oroscopo%O."
fi
